package com.huiju.estateagents.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.base.ResponseBean;
import com.huiju.estateagents.entity.TaShareActivity;
import com.huiju.estateagents.mapper.TaShareActivityMapper;
import com.huiju.estateagents.service.ITaShareActivityService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 拼团活动表  服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-10-17
 */
@Service
public class TaShareActivityServiceImpl extends ServiceImpl<TaShareActivityMapper, TaShareActivity> implements ITaShareActivityService {

    @Autowired
    private TaShareActivityMapper taShareActivityMapper;

    @Override
    public ResponseBean getList(Integer pageNum, Integer pageSize, String buildingId, String activityName, String status, LocalDateTime startTime, LocalDateTime endTime, Integer orgId) {
        ResponseBean responseBean = new ResponseBean();
        Page<TaShareActivity> page = new Page<>();
        page.setSize(pageSize == null ? 10 : pageSize);
        page.setCurrent(pageNum == null ? 1 : pageNum);

        QueryWrapper<TaShareActivity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(buildingId != null, "building_id", buildingId);
        queryWrapper.like(activityName != null, "activity_name", activityName);
        queryWrapper.eq(status != null, "status", status);
        queryWrapper.eq(startTime != null, "start_time", startTime);
        queryWrapper.eq(endTime != null, "end_time", endTime);
        queryWrapper.eq(orgId != null, "org_id", orgId);
        queryWrapper.orderByDesc("group_acticity_id");
        IPage<TaShareActivity> taNewsIPage = this.page(page, queryWrapper);

        responseBean.addSuccess(taNewsIPage);
        return responseBean;
    }

    @Override
    public void updateUnStartActivity(List<Integer> startGroupActivityId) {
        if (CollectionUtils.isNotEmpty(startGroupActivityId)){
            taShareActivityMapper.updateUnStartGroupActivity(startGroupActivityId);
        }
    }

    @Override
    public void updateEndActivity(List<Integer> endGroupActivityId) {
        if (CollectionUtils.isNotEmpty(endGroupActivityId)){
            taShareActivityMapper.updateEndGroupActivity(endGroupActivityId);
        }
    }
}
